



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【BZOJ 1770 】 [Usaco2009 Nov]lights 燈 dfs+异或方程组</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【BZOJ 1770 】 [Usaco2009 Nov]lights 燈 dfs+异或方程组</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 16:11:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这道题明显是异或方程组，然而解不一定唯一他要的是众多解中解为1的数的最小值，这个时候我们就需要dfs了我们dfs的时候就是枚举其有不确定解的数上选0或1从而推知其他解，由于我们dfs的时候先0后1，虽然我们选出的0多最后得到的0不一定多，但至少加上小小的剪枝(例如如果剩下的解全为0也不必已知解多就退出)，之后他无法将我们的时间复杂度搞到一个很困窘的地步，因为他在不确定解小于25时卡不到我们，但是一旦多了剪枝的效果就大了。</p>
<div>
<pre class="prettyprint linenums">#include &lt;cstdio&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;bitset&gt;<br />
#include &lt;iostream&gt;<br />
const int N=;<br />
const int Inf=0x3f3f3f3f;<br />
std::bitset&lt;N&gt; a[N],d[N],temp;<br />
int ans=Inf,n,m,b[N];<br />
bool god;<br />
void gauss(){<br />
    for(int i=,k=;k&lt;=n;i++,k++){<br />
        int t=;<br />
        for(int j=i;j&lt;=n;j++)<br />
            if(a[j][k]){t=j;break;}<br />
        if(!t){i--;continue;}<br />
        temp=a[t],a[t]=a[i],a[i]=temp;<br />
        for(int j=i+;j&lt;=n;j++)<br />
            if(a[j][k])a[j]^=a[i];<br />
    }<br />
    for(int i=,now=;i&lt;=n;i++){<br />
        while(now&lt;=n&amp;&amp;a[i][now]==)now++;<br />
        if(now&gt;n)break;<br />
        d[now]=a[i];<br />
    }<br />
}<br />
void dfs(int now,int have){<br />
    if(have&gt;=ans)return;<br />
    if(now==){ans=have;return;}<br />
    if(d[now][now]){<br />
        b[now]=d[now][n+];<br />
        for(int i=now+;i&lt;=n;i++)b[now]^=d[now][i]&amp;b[i];<br />
        dfs(now-,have+b[now]);<br />
        return;<br />
    }<br />
    b[now]=,dfs(now-,have);<br />
    b[now]=,dfs(now-,have+);<br />
}<br />
int main(){<br />
    scanf("%d%d",&amp;n,&amp;m);<br />
    for(int i=,x,y;i&lt;=m;i++)<br />
        scanf("%d%d",&amp;x,&amp;y),a[x][y]=,a[y][x]=;<br />
    for(int i=;i&lt;=n;i++)a[i][n+]=,a[i][i]=;<br />
    gauss(),dfs(n,),printf("%d",ans);<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j0jxlq.html">JavaScript中数据类型转换总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gozxeq.html">Vue中class与style绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11rj39.html">用Jquery获取select的value和text值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12m0k8.html">GLSL学习&lowbar;高斯滤波</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmkmwx9.html">yabeblog&period;me 关于Tomcat7部署 一台机器部署两个项目，一个用域名访问，一个用IP访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1vmkr9.html">android开发 socket接收图片并保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z17j319.html">Counting - SGU 117（快速幂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gepgkz8.html">第一百二十四节，JavaScriptCookie与存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jze7gw8.html">c&num; 获取客户端ip</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j26pv8.html">开涛spring3&lpar;6&period;6&rpar; - AOP 之 6&period;6 通知参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljx47e9.html">Heroku 如何上重置 PostgreSQL 数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1xd5mq.html">Spring&plus;SpringMVC&plus;MyBatis&plus;easyUI整合优化篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jew0l8.html">angularJS前台传list数组，后台springMVC接收数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy13jddq.html">剑指Offer&mdash;&mdash;巧妙使用sort&lpar;List&amp;lt&semi;T&amp;gt&semi;&comma;Comparator&amp;lt&semi;&quest; super T&amp;gt&semi;&rpar;比较器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdlopz9.html">hadoop常用操作命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjj7l39.html">shell编程基础&lpar;五&rpar;&colon; 正则表达式及其使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9604ooj9.html">python学习之切片</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvexd38.html">使用shell脚本监控用户登陆服务器并发送提示信息给微信</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjmw7o8.html">memcpy、memmove、memset、memchr、memcmp、strstr详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpm1ee9.html">NESTED内部事务异常会回滚 外部事务不会回滚 ；内部事务没有异常&comma;外部事务有异常 则整体事务都回滚</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8odleg1q.html">Lavavel5&period;5源代码 - 限流工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/qd5r7gv9.html">如何在hadoop中使用外部的python程序文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7706x1q.html">linux实现DNS轮询实现负载平衡</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xyogo9.html">linux文件IO操作篇 &lpar;一&rpar; 非缓冲文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnd47e38.html">嵌入式框架Zorb Framework搭建三：列表的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/93jg05g8.html">一步一步学Linq to sql（六）：探究特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r4wd0d8.html">c&num;根据ip获取城市地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/qloxjvxq.html">C&num;操作Excel文件&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qndlvlg8.html">Sql面试题之三（难度：简单&vert; 含答案）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mdx2768.html">BZOJ1222&lbrack;HNOI 2001&rsqb;产品加工</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
